Entity Relationship Diagram Model in Vue Diagram Control

An Entity Relationship (ER) diagram is a visual representation of a database structure. It displays entities (such as tables), their attributes (such as columns), and the relationships between those entities. In the Syncfusion® Diagram control, ER diagrams can be created by configuring nodes with ErShapeModel and connectors with ErConnectorShapeModel.

Entity nodes are added to the nodes property, and ER relationships are defined as connectors and added to the connectors property.

ER diagram elements

An ER diagram is built using the following main elements:

  • Entities - Represent database tables or objects, such as Customer, Order, or Product.
  • Fields - Represent columns or attributes inside an entity, such as CustomerID, Name, or Email.
  • Relationships - Represent how one entity is associated with another entity.

Creating ER entity nodes

An ER entity node represents a database entity, such as a table or object. It appears as a box that displays the entity name in the header and its fields as rows. The node shape can be defined by setting the type property to Er.

<template>
    <div id="app">
        <ejs-diagram id="diagram" ref="diagramObj" :width='width' :height='height' :nodes='nodes'></ejs-diagram>
    </div>
</template>

<script setup>
import { provide, ref, onMounted } from "vue";
import { DiagramComponent as EjsDiagram, ERDiagrams } from '@syncfusion/ej2-vue-diagrams';


// Define a basic ER entity (Customer table)
const customer = {
  id: 'Customer',
  offsetX: 400,
  offsetY: 300,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'Customer' }
    },
    fields: [
      {
        id: 'cust_id',
        name: 'CustomerID',
        dataType: 'INT',
        isPrimaryKey: true,
        constraints: ['NotNull']
      },
      {
        id: 'cust_firstname',
        name: 'FirstName',
        dataType: 'VARCHAR(50)',
        constraints: ['NotNull']
      },
      {
        id: 'cust_email',
        name: 'Email',
        dataType: 'VARCHAR(100)',
        constraints: ['Unique']
      }
    ]
  }
};

const nodes = [customer];

const width = "p";
const height = "600px";

provide('diagram', [ERDiagrams]);

</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <ejs-diagram id="diagram" ref="diagramObj" :width="width" :height="height" :nodes="nodes"></ejs-diagram>
    </div>
</template>

<script>
import { DiagramComponent, ERDiagrams } from '@syncfusion/ej2-vue-diagrams';

// Define a basic ER entity (Customer table)
var customer = {
  id: 'Customer',
  offsetX: 400,
  offsetY: 300,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'Customer' }
    },
    fields: [
      {
        id: 'cust_id',
        name: 'CustomerID',
        dataType: 'INT',
        isPrimaryKey: true,
        constraints: ['NotNull']
      },
      {
        id: 'cust_firstname',
        name: 'FirstName',
        dataType: 'VARCHAR(50)',
        constraints: ['NotNull']
      },
      {
        id: 'cust_email',
        name: 'Email',
        dataType: 'VARCHAR(100)',
        constraints: ['Unique']
      }
    ]
  }
};

export default {
    name: 'App',
    components: {
        'ejs-diagram': DiagramComponent,
    },
    data() {
        return {
            width: '100%',
            height: '600px',
            nodes: [customer],
        };
    },
    provide: { diagram: [ERDiagrams] },
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Configure the entity header

The header is the top section of an ER entity node that displays the entity name. The header appearance can be customized using the header property.

ER Header Property Description
annotation Defines the text content displayed in the header.
height Defines the height of the header area in pixels.
style Defines style properties such as fill color, text color, and font settings.
<template>
    <div id="app">
        <ejs-diagram id="diagram" ref="diagramObj" :width='width' :height='height' :nodes='nodes'></ejs-diagram>
    </div>
</template>

<script setup>
import { provide, ref, onMounted } from "vue";
import { DiagramComponent as EjsDiagram, ERDiagrams } from '@syncfusion/ej2-vue-diagrams';


// Define an ER entity with customized header
const customer = {
  id: 'Customer',
  offsetX: 400,
  offsetY: 300,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'CUSTOMER TABLE', style: {
        color: 'white',
        fontSize: 13,
        bold: true,
        fontFamily: 'Arial'
      }},
      height: 35,
      style: {
        fill: '#2E75B6'
      }
    },
    fields: [
      {
        id: 'cust_id',
        name: 'CustomerID',
        dataType: 'INT',
        isPrimaryKey: true
      },
      {
        id: 'cust_name',
        name: 'FirstName',
        dataType: 'VARCHAR(50)'
      },
      {
        id: 'cust_email',
        name: 'Email',
        dataType: 'VARCHAR(100)'
      }
    ]
  }
};

const nodes = [customer];

const width = "100%";
const height = "600px";

provide('diagram', [ERDiagrams]);

</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <ejs-diagram id="diagram" ref="diagramObj" :width="width" :height="height" :nodes="nodes"></ejs-diagram>
    </div>
</template>

<script>
import { DiagramComponent, ERDiagrams } from '@syncfusion/ej2-vue-diagrams';

// Define an ER entity with customized header
var customer = {
  id: 'Customer',
  offsetX: 400,
  offsetY: 300,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'CUSTOMER TABLE', style: {
        color: 'white',
        fontSize: 13,
        bold: true,
        fontFamily: 'Arial'
      }},
      height: 35,
      style: {
        fill: '#2E75B6'
      }
    },
    fields: [
      {
        id: 'cust_id',
        name: 'CustomerID',
        dataType: 'INT',
        isPrimaryKey: true
      },
      {
        id: 'cust_name',
        name: 'FirstName',
        dataType: 'VARCHAR(50)'
      },
      {
        id: 'cust_email',
        name: 'Email',
        dataType: 'VARCHAR(100)'
      }
    ]
  }
};


export default {
    name: 'App',
    components: {
        'ejs-diagram': DiagramComponent,
    },
    data() {
        return {
            width: '100%',
            height: '600px',
            nodes: [customer],
        };
    },
    provide: { diagram: [ERDiagrams] },
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

NOTE

If no header is specified, a default header is automatically added to the ER entity node with the default style and height.

Define entity fields

Fields represent the columns or attributes of an entity. They can be defined using the fields property. Each field can display information such as the field name, data type, and key constraints, including primary key, foreign key, unique, and not null.

ER Field Property Description
id Defines the unique identifier for the field within the entity.
name Defines the display name of the field.
dataType Defines the data type of the field, such as INT, VARCHAR(255), or BOOLEAN.
isPrimaryKey Indicates whether the field is the primary key of the entity.
isForeignKey Indicates whether the field is a foreign key that references another entity.
constraints Defines additional constraints applied to the field. Accepts one or more ErFieldConstraint values.
style Defines the visual style of the ER field row. Supports standard shape style properties such as fill, stroke color, stroke width, opacity, and other supported diagram style values. Field-level style values override applicable values from field defaults.
annotation Defines text styling for the ER field row. Only annotation style property is applicable. The annotation content property is ignored.
<template>
    <div id="app">
        <ejs-diagram id="diagram" ref="diagramObj" :width='width' :height='height' :nodes='nodes'></ejs-diagram>
    </div>
</template>

<script setup>
import { provide, ref, onMounted } from "vue";
import { DiagramComponent as EjsDiagram, ERDiagrams } from '@syncfusion/ej2-vue-diagrams';


// Define an ER entity with various field properties
var product = {
  id: 'Product',
  offsetX: 400,
  offsetY: 350,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'Product' }
    },
    fields: [
      {
        id: 'prod_id',
        name: 'ProductID',
        dataType: 'INT',
        isPrimaryKey: true,
        constraints: ['NotNull']
      },
      {
        id: 'prod_code',
        name: 'ProductCode',
        dataType: 'VARCHAR(50)',
        constraints: ['NotNull', 'Unique']
      },
      {
        id: 'prod_name',
        name: 'ProductName',
        dataType: 'VARCHAR(150)',
        constraints: ['NotNull']
      },
      {
        id: 'prod_price',
        name: 'Price',
        dataType: 'DECIMAL(10,2)',
        constraints: ['NotNull']
      },
      {
        id: 'prod_desc',
        name: 'Description',
        dataType: 'TEXT'
      },
      {
        id: 'prod_catid',
        name: 'CategoryID',
        dataType: 'INT',
        isForeignKey: true
      }
    ]
  }
};

const nodes = [product];

const width = "100%";
const height = "600px";

provide('diagram', [ERDiagrams]);

</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <ejs-diagram id="diagram" ref="diagramObj" :width="width" :height="height" :nodes="nodes"></ejs-diagram>
    </div>
</template>

<script>
import { DiagramComponent, ERDiagrams } from '@syncfusion/ej2-vue-diagrams';

// Define an ER entity with various field properties
var product = {
  id: 'Product',
  offsetX: 400,
  offsetY: 350,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'Product' }
    },
    fields: [
      {
        id: 'prod_id',
        name: 'ProductID',
        dataType: 'INT',
        isPrimaryKey: true,
        constraints: ['NotNull']
      },
      {
        id: 'prod_code',
        name: 'ProductCode',
        dataType: 'VARCHAR(50)',
        constraints: ['NotNull', 'Unique']
      },
      {
        id: 'prod_name',
        name: 'ProductName',
        dataType: 'VARCHAR(150)',
        constraints: ['NotNull']
      },
      {
        id: 'prod_price',
        name: 'Price',
        dataType: 'DECIMAL(10,2)',
        constraints: ['NotNull']
      },
      {
        id: 'prod_desc',
        name: 'Description',
        dataType: 'TEXT'
      },
      {
        id: 'prod_catid',
        name: 'CategoryID',
        dataType: 'INT',
        isForeignKey: true
      }
    ]
  }
};


export default {
    name: 'App',
    components: {
        'ejs-diagram': DiagramComponent,
    },
    data() {
        return {
            width: '100%',
            height: '600px',
            nodes: [product],
        };
    },
    provide: { diagram: [ERDiagrams] },
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

NOTE

If no fields are specified, a default single field is automatically added to the ER entity node.

Add or remove ER fields at runtime

ER fields can be updated after the diagram is rendered by using the addErField and removeErField methods. These methods help add new fields to an ER entity node or remove existing fields without recreating the diagram.

The addErField method adds a field to an ER entity node.

let entityNode = diagram.nodes[0];
let newField = {
    id: 'customer_phone',
    name: 'Phone',
    dataType: 'VARCHAR(20)'
};

diagram.addErField(entityNode, newField);

To insert the field at a specific position, pass the index as the third argument:

diagram.addErField(entityNode, newField, 2);

The removeErField method removes an existing field from an ER entity node.

// Find the field that needs to be removed from the ER entity.
let fieldToRemove = entityNode.shape.fields.find(
    field => field.id === 'customer_phone'
);

if (fieldToRemove) {
    diagram.removeErField(entityNode, fieldToRemove);
}

Configure default field appearance

The fieldDefaults property defines the default visual appearance for all fields in an ER entity node. These settings are applied to every field unless they are overridden by individual field-level style settings.

ER Field Defaults Property Description
alternateRowColors Defines exactly two colors cycled across field rows in alternating order. Row 0 uses alternateRowColors[0], row 1 uses alternateRowColors[1], row 2 uses alternateRowColors[0], and so on.
height Defines the default height of each ER entity field row.

Style ER entities and fields

The appearance of ER entities and their fields can be customized using style properties. The node-level style property controls the overall ER entity appearance, while individual field style values can override applicable styles for specific field rows.

<template>
    <div id="app">
        <ejs-diagram id="diagram" ref="diagramObj" :width='width' :height='height' :nodes='nodes'></ejs-diagram>
    </div>
</template>

<script setup>
import { provide, ref, onMounted } from "vue";
import { DiagramComponent as EjsDiagram, ERDiagrams } from '@syncfusion/ej2-vue-diagrams';


// Define ER entities with custom styling
const customer = {
  id: 'Customer',
  offsetX: 300,
  offsetY: 300,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'CUSTOMER TABLE', style: { bold: true, color: 'white' } },
      height: 35,
      style: {
        fill: '#2E75B6',
        color: 'white',
        fontSize: 12,
        bold: true
      }
    },
    fields: [
      {
        id: 'cust_id',
        name: 'CustomerID',
        dataType: 'INT',
        isPrimaryKey: true
      },
      {
        id: 'cust_firstname',
        name: 'FirstName',
        dataType: 'VARCHAR(50)'
      },
      {
        id: 'cust_email',
        name: 'Email',
        dataType: 'VARCHAR(100)'
      }
    ],
    fieldDefaults: {
      alternateRowColors: ['#ffffff', '#E7F0F7']
    },
  },
  style: {
    fill: '#ffffff',
    strokeColor: '#2E75B6',
    strokeWidth: 1
  }
};

const product = {
  id: 'Product',
  offsetX: 850,
  offsetY: 300,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'PRODUCT CATALOG', style: { bold: true, color: 'white' } },
      height: 35,
      style: {
        fill: '#70AD47',
        color: 'white',
        fontSize: 12,
        bold: true
      }
    },
    fields: [
      {
        id: 'prod_id',
        name: 'ProductID',
        dataType: 'INT',
        isPrimaryKey: true,
        style: { fill: '#FFE699' }
      },
      {
        id: 'prod_name',
        name: 'ProductName',
        dataType: 'VARCHAR(150)'
      },
      {
        id: 'prod_price',
        name: 'Price',
        dataType: 'DECIMAL(10,2)',
        style: { fill: '#C6E0B4' }
      }
    ],
    fieldDefaults: {
      alternateRowColors: ['#ffffff', '#F2F2F2']
    },
  },
  style: {
    fill: '#ffffff',
    strokeColor: '#70AD47',
    strokeWidth: 1.5,
  }
};

const nodes = [customer, product];

const width = "100%";
const height = "600px";

provide('diagram', [ERDiagrams]);

</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <ejs-diagram id="diagram" ref="diagramObj" :width="width" :height="height" :nodes="nodes"></ejs-diagram>
    </div>
</template>

<script>
import { DiagramComponent, ERDiagrams } from '@syncfusion/ej2-vue-diagrams';

// Define ER entities with custom styling
var customer = {
  id: 'Customer',
  offsetX: 300,
  offsetY: 300,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'CUSTOMER TABLE', style: { bold: true, color: 'white' } },
      height: 35,
      style: {
        fill: '#2E75B6',
        color: 'white',
        fontSize: 12,
        bold: true
      }
    },
    fields: [
      {
        id: 'cust_id',
        name: 'CustomerID',
        dataType: 'INT',
        isPrimaryKey: true
      },
      {
        id: 'cust_firstname',
        name: 'FirstName',
        dataType: 'VARCHAR(50)'
      },
      {
        id: 'cust_email',
        name: 'Email',
        dataType: 'VARCHAR(100)'
      }
    ],
    fieldDefaults: {
      alternateRowColors: ['#ffffff', '#E7F0F7']
    },
  },
  style: {
    fill: '#ffffff',
    strokeColor: '#2E75B6',
    strokeWidth: 1
  }
};

var product = {
  id: 'Product',
  offsetX: 850,
  offsetY: 300,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'PRODUCT CATALOG', style: { bold: true, color: 'white' } },
      height: 35,
      style: {
        fill: '#70AD47',
        color: 'white',
        fontSize: 12,
        bold: true
      }
    },
    fields: [
      {
        id: 'prod_id',
        name: 'ProductID',
        dataType: 'INT',
        isPrimaryKey: true,
        style: { fill: '#FFE699' }
      },
      {
        id: 'prod_name',
        name: 'ProductName',
        dataType: 'VARCHAR(150)'
      },
      {
        id: 'prod_price',
        name: 'Price',
        dataType: 'DECIMAL(10,2)',
        style: { fill: '#C6E0B4' }
      }
    ],
    fieldDefaults: {
      alternateRowColors: ['#ffffff', '#F2F2F2']
    },
  },
  style: {
    fill: '#ffffff',
    strokeColor: '#70AD47',
    strokeWidth: 1.5,
  }
};

export default {
    name: 'App',
    components: {
        'ejs-diagram': DiagramComponent,
    },
    data() {
        return {
            width: '100%',
            height: '600px',
            nodes: [customer, product],
        };
    },
    provide: { diagram: [ERDiagrams] },
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

NOTE

Field-level styles override applicable node-level and field default styles.

Track entity field changes

The erEntityChanged event is triggered when ER entity fields are added, removed, or reordered. This event provides the previous and updated entity states, which can be used to track modifications, validate field changes, or synchronize updates with an external data source.

erEntityChanged: (args) => {
    if (args.cause === 'FieldsReorder' && args.state === 'Completed') {
        console.log('ER fields reordered successfully.');
    }
}

Creating ER relationships

Relationships define how one ER entity is connected to another entity. In the Diagram control, relationships are created using ER connectors. They are rendered as lines with multiplicity symbols at the connector ends.The connector shape can be defined by setting the type property to Er.

ER Connector Shape Property Description
type Defines the connector shape type as 'Er'. Default: 'Er'.
relationship Defines whether the relationship is identifying or non-identifying.
sourceMultiplicity Defines the Crow’s Foot multiplicity rendered at the source end of the ER connector.
targetMultiplicity Defines the Crow’s Foot multiplicity rendered at the target end of the ER connector.

Define relationship multiplicity

Multiplicity defines how many instances of one entity can be associated with instances of another entity. In ER diagrams, multiplicity is represented using Crow’s Foot symbols at the source and target ends of a connector.

Multiplicity Type Meaning Example Image
One Represents a single participation marker. A customer has one primary account. One Multiplicity
OneAndOnlyOne Represents mandatory participation of exactly one instance. A user must have exactly one profile. OneAndOnlyOne Multiplicity
Many Represents multiple instances. A customer can have many orders. Many Multiplicity
ZeroOrOne Represents zero or one instance. An employee may have zero or one manager badge. ZeroOrOne Multiplicity
OneOrMany Represents one or more instances. A department must have one or more employees. OneOrMany Multiplicity
ZeroOrMany Represents zero or more instances. A customer may have zero or more wish list items. ZeroOrMany Multiplicity
<template>
    <div id="app">
        <ejs-diagram id="diagram" ref="diagramObj" :width='width' :height='height':connectors='connectors'></ejs-diagram>
    </div>
</template>

<script setup>
import { provide, ref, onMounted } from "vue";
import { DiagramComponent as EjsDiagram, ERDiagrams, ERCardinality } from '@syncfusion/ej2-vue-diagrams';


// Define ER connectors with all multiplicity types
var connectors = [
  // One
  {
    id: 'er_one',
    sourcePoint: { x: 100, y: 100 },
    targetPoint: { x: 300, y: 100 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'One' },
      targetMultiplicity: { type: 'One' }
    }
  },
  // Many
  {
    id: 'er_many',
    sourcePoint: { x: 100, y: 140 },
    targetPoint: { x: 300, y: 140 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'Many' },
      targetMultiplicity: { type: 'Many' }
    }
  },
  // One and only one
  {
    id: 'er_one_or_one',
    sourcePoint: { x: 100, y: 180 },
    targetPoint: { x: 300, y: 180 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'OneAndOnlyOne' },
      targetMultiplicity: { type: 'OneAndOnlyOne' }
    }
  },
  // One or many
  {
    id: 'er_one_or_many',
    sourcePoint: { x: 100, y: 220 },
    targetPoint: { x: 300, y: 220 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'OneOrMany' },
      targetMultiplicity: { type: 'OneOrMany' }
    }
  },
  // Zero or one
  {
    id: 'er_zero_or_one',
    sourcePoint: { x: 100, y: 260 },
    targetPoint: { x: 300, y: 260 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'ZeroOrOne' },
      targetMultiplicity: { type: 'ZeroOrOne' }
    }
  },
  // Zero or many
  {
    id: 'er_zero_or_many',
    sourcePoint: { x: 100, y: 300 },
    targetPoint: { x: 300, y: 300 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'ZeroOrMany' },
      targetMultiplicity: { type: 'ZeroOrMany' }
    }
  }
];


const width = "100%";
const height = "600px";

provide('diagram', [ERDiagrams]);

</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <ejs-diagram id="diagram" ref="diagramObj" :width="width" :height="height" :connectors="connectors"></ejs-diagram>
    </div>
</template>

<script>
import { DiagramComponent, ERDiagrams, ERCardinality } from '@syncfusion/ej2-vue-diagrams';

// Define ER connectors with all multiplicity types
var connectors = [
  // One
  {
    id: 'er_one',
    sourcePoint: { x: 100, y: 100 },
    targetPoint: { x: 300, y: 100 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'One' },
      targetMultiplicity: { type: 'One' }
    }
  },
  // Many
  {
    id: 'er_many',
    sourcePoint: { x: 100, y: 140 },
    targetPoint: { x: 300, y: 140 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'Many' },
      targetMultiplicity: { type: 'Many' }
    }
  },
  // One and only one
  {
    id: 'er_one_or_one',
    sourcePoint: { x: 100, y: 180 },
    targetPoint: { x: 300, y: 180 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'OneAndOnlyOne' },
      targetMultiplicity: { type: 'OneAndOnlyOne' }
    }
  },
  // One or many
  {
    id: 'er_one_or_many',
    sourcePoint: { x: 100, y: 220 },
    targetPoint: { x: 300, y: 220 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'OneOrMany' },
      targetMultiplicity: { type: 'OneOrMany' }
    }
  },
  // Zero or one
  {
    id: 'er_zero_or_one',
    sourcePoint: { x: 100, y: 260 },
    targetPoint: { x: 300, y: 260 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'ZeroOrOne' },
      targetMultiplicity: { type: 'ZeroOrOne' }
    }
  },
  // Zero or many
  {
    id: 'er_zero_or_many',
    sourcePoint: { x: 100, y: 300 },
    targetPoint: { x: 300, y: 300 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'ZeroOrMany' },
      targetMultiplicity: { type: 'ZeroOrMany' }
    }
  }
];

export default {
    name: 'App',
    components: {
        'ejs-diagram': DiagramComponent,
    },
    data() {
        return {
            width: '100%',
            height: '600px',
            connectors: connectors,
        };
    },
    provide: { diagram: [ERDiagrams] },
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

See also

Entity Relationship Diagrams in React Diagram Component

An Entity Relationship (ER) diagram is a visual representation of a database structure. It displays entities (such as tables), their attributes (such as columns), and the relationships between those entities. In the Syncfusion® React Diagram component, ER diagrams can be created by configuring nodes with ErShapeModel and connectors with ErConnectorShapeModel.

ER entity nodes are added to the nodes property, and ER relationships are defined as connectors and added to the connectors property.

ER diagram elements

An ER diagram is built using the following main elements:

  • Entities - Represent database tables or objects, such as Customer, Order, or Product.
  • Fields - Represent columns or attributes inside an entity, such as CustomerID, Name, or Email.
  • Relationships - Represent how one entity is associated with another entity.

Creating ER entity nodes

An ER entity node represents a database entity, such as a table or object. It appears as a box that displays the entity name in the header and its fields as rows. The node shape can be defined by setting the type property to Er.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Diagram, ErDiagrams } from "@syncfusion/ej2-react-diagrams";

Diagram.Inject(ErDiagrams);

// Define a basic ER entity (Customer table)
const customer = {
  id: 'Customer',
  offsetX: 400,
  offsetY: 300,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'Customer' }
    },
    fields: [
      {
        id: 'cust_id',
        name: 'CustomerID',
        dataType: 'INT',
        isPrimaryKey: true,
        constraints: ['NotNull']
      },
      {
        id: 'cust_firstname',
        name: 'FirstName',
        dataType: 'VARCHAR(50)',
        constraints: ['NotNull']
      },
      {
        id: 'cust_email',
        name: 'Email',
        dataType: 'VARCHAR(100)',
        constraints: ['Unique']
      }
    ]
  }
};

// Initialize diagram control
function App() {
  return (
    <DiagramComponent id="container"
      width={'100%'}
      height={'600px'}
      nodes={[customer]}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Diagram, ErDiagrams } from "@syncfusion/ej2-react-diagrams";
import { NodeModel, ErShapeModel } from "@syncfusion/ej2-diagrams";

Diagram.Inject(ErDiagrams);

// Define a basic ER entity (Customer table)
const customer: NodeModel = {
  id: 'Customer',
  offsetX: 400,
  offsetY: 300,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'Customer' }
    },
    fields: [
      {
        id: 'cust_id',
        name: 'CustomerID',
        dataType: 'INT',
        isPrimaryKey: true,
        constraints: ['NotNull']
      },
      {
        id: 'cust_firstname',
        name: 'FirstName',
        dataType: 'VARCHAR(50)',
        constraints: ['NotNull']
      },
      {
        id: 'cust_email',
        name: 'Email',
        dataType: 'VARCHAR(100)',
        constraints: ['Unique']
      }
    ]
  } as ErShapeModel
};

// Initialize diagram control
function App() {
  return (
    <DiagramComponent id="container"
      width={'100%'}
      height={'600px'}
      nodes={[customer]}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Configure the entity header

The header is the top section of an ER entity node that displays the entity name. The header appearance can be customized using the header property.

ER Header Property Description
annotation Defines the text content displayed in the header.
height Defines the height of the header area in pixels.
style Defines style properties such as fill color, text color, and font settings.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Diagram, ErDiagrams } from "@syncfusion/ej2-react-diagrams";

Diagram.Inject(ErDiagrams);

// Define an ER entity with customized header
const customer = {
  id: 'Customer',
  offsetX: 400,
  offsetY: 300,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'CUSTOMER TABLE', style: {
        color: 'white',
        fontSize: 13,
        bold: true,
        fontFamily: 'Arial'
      }},
      height: 35,
      style: {
        fill: '#2E75B6'
      }
    },
    fields: [
      {
        id: 'cust_id',
        name: 'CustomerID',
        dataType: 'INT',
        isPrimaryKey: true
      },
      {
        id: 'cust_name',
        name: 'FirstName',
        dataType: 'VARCHAR(50)'
      },
      {
        id: 'cust_email',
        name: 'Email',
        dataType: 'VARCHAR(100)'
      }
    ]
  }
};

// Initialize diagram control
function App() {
  return (
    <DiagramComponent id="container"
      width={'100%'}
      height={'600px'}
      nodes={[customer]}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Diagram, ErDiagrams } from "@syncfusion/ej2-react-diagrams";
import { NodeModel, ErShapeModel } from "@syncfusion/ej2-diagrams";

Diagram.Inject(ErDiagrams);

// Define an ER entity with customized header
const customer: NodeModel = {
  id: 'Customer',
  offsetX: 400,
  offsetY: 300,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'CUSTOMER TABLE', style: {
        color: 'white',
        fontSize: 13,
        bold: true,
        fontFamily: 'Arial'
      }},
      height: 35,
      style: {
        fill: '#2E75B6'
      }
    },
    fields: [
      {
        id: 'cust_id',
        name: 'CustomerID',
        dataType: 'INT',
        isPrimaryKey: true
      },
      {
        id: 'cust_name',
        name: 'FirstName',
        dataType: 'VARCHAR(50)'
      },
      {
        id: 'cust_email',
        name: 'Email',
        dataType: 'VARCHAR(100)'
      }
    ]
  } as ErShapeModel
};

// Initialize diagram control
function App() {
  return (
    <DiagramComponent id="container"
      width={'100%'}
      height={'600px'}
      nodes={[customer]}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

NOTE

If no header is specified, a default header is automatically added to the ER entity node with the default style and height.

Define entity fields

Fields represent the columns or attributes of an entity. They can be defined using the fields property. Each field can display information such as the field name, data type, and key constraints, including primary key, foreign key, unique, and not null.

ER Field Property Description
id Defines the unique identifier for the field within the entity.
name Defines the display name of the field.
dataType Defines the data type of the field, such as INT, VARCHAR(255), or BOOLEAN.
isPrimaryKey Indicates whether the field is the primary key of the entity.
isForeignKey Indicates whether the field is a foreign key that references another entity.
constraints Defines additional constraints applied to the field. Accepts one or more ErFieldConstraint values.
style Defines the visual style of the ER field row. Supports standard shape style properties such as fill, stroke color, stroke width, opacity, and other supported diagram style values. Field-level style values override applicable values from field defaults.
annotation Defines text styling for the ER field row. Only annotation style property is applicable. The annotation content property is ignored.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Diagram, ErDiagrams } from "@syncfusion/ej2-react-diagrams";

Diagram.Inject(ErDiagrams);

// Define an ER entity with various field properties
const product = {
  id: 'Product',
  offsetX: 400,
  offsetY: 350,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'Product' }
    },
    fields: [
      {
        id: 'prod_id',
        name: 'ProductID',
        dataType: 'INT',
        isPrimaryKey: true,
        constraints: ['NotNull']
      },
      {
        id: 'prod_code',
        name: 'ProductCode',
        dataType: 'VARCHAR(50)',
        constraints: ['NotNull', 'Unique']
      },
      {
        id: 'prod_name',
        name: 'ProductName',
        dataType: 'VARCHAR(150)',
        constraints: ['NotNull']
      },
      {
        id: 'prod_price',
        name: 'Price',
        dataType: 'DECIMAL(10,2)',
        constraints: ['NotNull']
      },
      {
        id: 'prod_desc',
        name: 'Description',
        dataType: 'TEXT'
      },
      {
        id: 'prod_catid',
        name: 'CategoryID',
        dataType: 'INT',
        isForeignKey: true
      }
    ]
  }
};

// Initialize diagram control
function App() {
  return (
    <DiagramComponent id="container"
      width={'100%'}
      height={'600px'}
      nodes={[product]}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Diagram, ErDiagrams } from "@syncfusion/ej2-react-diagrams";
import { NodeModel, ErShapeModel, ErFieldModel } from "@syncfusion/ej2-diagrams";

Diagram.Inject(ErDiagrams);

// Define an ER entity with various field properties
const product: NodeModel = {
  id: 'Product',
  offsetX: 400,
  offsetY: 350,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'Product' }
    },
    fields: [
      {
        id: 'prod_id',
        name: 'ProductID',
        dataType: 'INT',
        isPrimaryKey: true,
        constraints: ['NotNull']
      },
      {
        id: 'prod_code',
        name: 'ProductCode',
        dataType: 'VARCHAR(50)',
        constraints: ['NotNull', 'Unique']
      },
      {
        id: 'prod_name',
        name: 'ProductName',
        dataType: 'VARCHAR(150)',
        constraints: ['NotNull']
      },
      {
        id: 'prod_price',
        name: 'Price',
        dataType: 'DECIMAL(10,2)',
        constraints: ['NotNull']
      },
      {
        id: 'prod_desc',
        name: 'Description',
        dataType: 'TEXT'
      },
      {
        id: 'prod_catid',
        name: 'CategoryID',
        dataType: 'INT',
        isForeignKey: true
      }
    ] as ErFieldModel[]
  } as ErShapeModel
};

// Initialize diagram control
function App() {
  return (
    <DiagramComponent id="container"
      width={'100%'}
      height={'600px'}
      nodes={[product]}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

NOTE

If no fields are specified, a default single field is automatically added to the ER entity node.

Add or remove ER fields at runtime

ER fields can be updated after the diagram is rendered by using the addErField and removeErField methods. These methods help add new fields to an ER entity node or remove existing fields without recreating the diagram.

The addErField method adds a field to an ER entity node.

let entityNode = diagramInstance.nodes[0];
let newField = {
    id: 'customer_phone',
    name: 'Phone',
    dataType: 'VARCHAR(20)'
};

diagramInstance.addErField(entityNode, newField);

To insert the field at a specific position, pass the index as the third argument:

diagramInstance.addErField(entityNode, newField, 2);

The removeErField method removes an existing field from an ER entity node.

// Find the field that needs to be removed from the ER entity.
let fieldToRemove = entityNode.shape.fields.find(
    field => field.id === 'customer_phone'
);

if (fieldToRemove) {
    diagramInstance.removeErField(entityNode, fieldToRemove);
}

Configure default field appearance

The fieldDefaults property defines the default visual appearance for all fields in an ER entity node. These settings are applied to every field unless they are overridden by individual field-level style settings.

ER Field Defaults Property Description
alternateRowColors Defines exactly two colors cycled across field rows in alternating order. Row 0 uses alternateRowColors[0], row 1 uses alternateRowColors[1], row 2 uses alternateRowColors[0], and so on.
height Defines the default height of each ER entity field row.

Style ER entities and fields

The appearance of ER entities and their fields can be customized using style properties. The node-level style property controls the overall ER entity appearance, while individual field style values can override applicable styles for specific field rows.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Diagram, ErDiagrams } from "@syncfusion/ej2-react-diagrams";

Diagram.Inject(ErDiagrams);

// Define ER entities with custom styling
const customer = {
  id: 'Customer',
  offsetX: 300,
  offsetY: 300,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'CUSTOMER TABLE', style: { bold: true, color: 'white' } },
      height: 35,
      style: {
        fill: '#2E75B6',
        color: 'white',
        fontSize: 12,
        bold: true
      }
    },
    fields: [
      {
        id: 'cust_id',
        name: 'CustomerID',
        dataType: 'INT',
        isPrimaryKey: true
      },
      {
        id: 'cust_firstname',
        name: 'FirstName',
        dataType: 'VARCHAR(50)'
      },
      {
        id: 'cust_email',
        name: 'Email',
        dataType: 'VARCHAR(100)'
      }
    ],
    fieldDefaults: {
      alternateRowColors: ['#ffffff', '#E7F0F7']
    },
  },
  style: {
    fill: '#ffffff',
    strokeColor: '#2E75B6',
    strokeWidth: 1
  }
};

const product = {
  id: 'Product',
  offsetX: 550,
  offsetY: 300,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'PRODUCT CATALOG', style: { bold: true, color: 'white' } },
      height: 35,
      style: {
        fill: '#70AD47',
        color: 'white',
        fontSize: 12,
        bold: true
      }
    },
    fields: [
      {
        id: 'prod_id',
        name: 'ProductID',
        dataType: 'INT',
        isPrimaryKey: true,
        style: { fill: '#FFE699' }
      },
      {
        id: 'prod_name',
        name: 'ProductName',
        dataType: 'VARCHAR(150)'
      },
      {
        id: 'prod_price',
        name: 'Price',
        dataType: 'DECIMAL(10,2)',
        style: { fill: '#C6E0B4' }
      }
    ],
    fieldDefaults: {
      alternateRowColors: ['#ffffff', '#F2F2F2']
    },
  },
  style: {
    fill: '#ffffff',
    strokeColor: '#70AD47',
    strokeWidth: 1.5,
  }
};

// Initialize diagram control
function App() {
  return (
    <DiagramComponent id="container"
      width={'100%'}
      height={'600px'}
      nodes={[customer, product]}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Diagram, ErDiagrams } from "@syncfusion/ej2-react-diagrams";
import { NodeModel, ErShapeModel, ErFieldModel } from "@syncfusion/ej2-diagrams";

Diagram.Inject(ErDiagrams);

// Define ER entities with custom styling
const customer: NodeModel = {
  id: 'Customer',
  offsetX: 300,
  offsetY: 300,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'CUSTOMER TABLE', style: { bold: true, color: 'white' } },
      height: 35,
      style: {
        fill: '#2E75B6',
        color: 'white',
        fontSize: 12,
        bold: true
      }
    },
    fields: [
      {
        id: 'cust_id',
        name: 'CustomerID',
        dataType: 'INT',
        isPrimaryKey: true
      },
      {
        id: 'cust_firstname',
        name: 'FirstName',
        dataType: 'VARCHAR(50)'
      },
      {
        id: 'cust_email',
        name: 'Email',
        dataType: 'VARCHAR(100)'
      }
    ] as ErFieldModel[],
    fieldDefaults: {
      alternateRowColors: ['#ffffff', '#E7F0F7']
    },
  } as ErShapeModel,
  style: {
    fill: '#ffffff',
    strokeColor: '#2E75B6',
    strokeWidth: 1,
  }
};

const product: NodeModel = {
  id: 'Product',
  offsetX: 550,
  offsetY: 300,
  shape: {
    type: 'Er',
    header: {
      annotation: { content: 'PRODUCT CATALOG' },
      height: 35,
      style: {
        fill: '#70AD47',
        color: 'white',
        fontSize: 12,
        bold: true
      }
    },
    fields: [
      {
        id: 'prod_id',
        name: 'ProductID',
        dataType: 'INT',
        isPrimaryKey: true,
        style: { fill: '#FFE699' }
      },
      {
        id: 'prod_name',
        name: 'ProductName',
        dataType: 'VARCHAR(150)'
      },
      {
        id: 'prod_price',
        name: 'Price',
        dataType: 'DECIMAL(10,2)',
        style: { fill: '#C6E0B4' }
      }
    ] as ErFieldModel[],
    fieldDefaults: {
      alternateRowColors: ['#ffffff', '#F2F2F2']
    },
  } as ErShapeModel,
  style: {
    fill: '#ffffff',
    strokeColor: '#70AD47',
    strokeWidth: 1.5,
  }
};

// Initialize diagram control
function App() {
  return (
    <DiagramComponent id="container"
      width={'100%'}
      height={'600px'}
      nodes={[customer, product]}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

NOTE

Field-level styles override applicable node-level and field default styles.

Track entity field changes

The erEntityChanged event is triggered when ER entity fields are added, removed, or reordered. This event provides the previous and updated entity states, which can be used to track modifications, validate field changes, or synchronize updates with an external data source.

erEntityChanged = {(args: IErEntityChangedEventArgs) => {
    if (args.cause === 'FieldsReorder' && args.state === 'Completed') {
        console.log('ER fields reordered successfully.');
    }
}}

Creating ER relationships

Relationships define how one ER entity is connected to another entity. In the Diagram control, relationships are created using ER connectors. They are rendered as lines with multiplicity symbols at the connector ends.The connector shape can be defined by setting the type property to Er.

ER Connector Shape Property Description
type Defines the connector shape type as 'Er'. Default: 'Er'.
relationship Defines whether the relationship is identifying or non-identifying.
sourceMultiplicity Defines the Crow’s Foot multiplicity rendered at the source end of the ER connector.
targetMultiplicity Defines the Crow’s Foot multiplicity rendered at the target end of the ER connector.

Define relationship multiplicity

Multiplicity defines how many instances of one entity can be associated with instances of another entity. In ER diagrams, multiplicity is represented using Crow’s Foot symbols at the source and target ends of a connector.

Multiplicity Type Meaning Example Image
One Represents a single participation marker. A customer has one primary account. One Multiplicity
OneAndOnlyOne Represents mandatory participation of exactly one instance. A user must have exactly one profile. OneAndOnlyOne Multiplicity
Many Represents multiple instances. A customer can have many orders. Many Multiplicity
ZeroOrOne Represents zero or one instance. An employee may have zero or one manager badge. ZeroOrOne Multiplicity
OneOrMany Represents one or more instances. A department must have one or more employees. OneOrMany Multiplicity
ZeroOrMany Represents zero or more instances. A customer may have zero or more wish list items. ZeroOrMany Multiplicity
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Diagram, ErDiagrams } from "@syncfusion/ej2-react-diagrams";
import { ConnectorModel, ErConnectorShapeModel, ErMultiplicityTypes } from "@syncfusion/ej2-diagrams";

Diagram.Inject(ErDiagrams);

// Define ER connectors with all multiplicity types
const connectors = [
  // One
  {
    id: 'er_one',
    sourcePoint: { x: 100, y: 100 },
    targetPoint: { x: 300, y: 100 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'One' },
      targetMultiplicity: { type: 'One' }
    }
  },
  // Many
  {
    id: 'er_many',
    sourcePoint: { x: 100, y: 140 },
    targetPoint: { x: 300, y: 140 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'Many' },
      targetMultiplicity: { type: 'Many' }
    }
  },
  // One and only one
  {
    id: 'er_one_or_one',
    sourcePoint: { x: 100, y: 180 },
    targetPoint: { x: 300, y: 180 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'OneAndOnlyOne' },
      targetMultiplicity: { type: 'OneAndOnlyOne' }
    }
  },
  // One or many
  {
    id: 'er_one_or_many',
    sourcePoint: { x: 100, y: 220 },
    targetPoint: { x: 300, y: 220 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'OneOrMany' },
      targetMultiplicity: { type: 'OneOrMany' }
    }
  },
  // Zero or one
  {
    id: 'er_zero_or_one',
    sourcePoint: { x: 100, y: 260 },
    targetPoint: { x: 300, y: 260 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'ZeroOrOne' },
      targetMultiplicity: { type: 'ZeroOrOne' }
    }
  },
  // Zero or many
  {
    id: 'er_zero_or_many',
    sourcePoint: { x: 100, y: 300 },
    targetPoint: { x: 300, y: 300 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'ZeroOrMany' },
      targetMultiplicity: { type: 'ZeroOrMany' }
    }
  }
];

// Initialize diagram control
function App() {
  return (
    <DiagramComponent id="container"
      width={'100%'}
      height={'600px'}
      nodes={[customer, order]}
      connectors={connectors}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Diagram, ErDiagrams } from "@syncfusion/ej2-react-diagrams";
import { ConnectorModel, ErConnectorShapeModel } from "@syncfusion/ej2-diagrams";

Diagram.Inject(ErDiagrams);

// Define ER connectors with all multiplicity types
const connectors: ConnectorModel[] = [
  // One
  {
    id: 'er_one',
    sourcePoint: { x: 100, y: 100 },
    targetPoint: { x: 300, y: 100 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'One' },
      targetMultiplicity: { type: 'One' }
    } as ErConnectorShapeModel
  },
  // Many
  {
    id: 'er_many',
    sourcePoint: { x: 100, y: 140 },
    targetPoint: { x: 300, y: 140 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'Many' },
      targetMultiplicity: { type: 'Many' }
    } as ErConnectorShapeModel
  },
  // One and only one
  {
    id: 'er_one_or_one',
    sourcePoint: { x: 100, y: 180 },
    targetPoint: { x: 300, y: 180 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'OneAndOnlyOne' },
      targetMultiplicity: { type: 'OneAndOnlyOne' }
    } as ErConnectorShapeModel
  },
  // One or many
  {
    id: 'er_one_or_many',
    sourcePoint: { x: 100, y: 220 },
    targetPoint: { x: 300, y: 220 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'OneOrMany' },
      targetMultiplicity: { type: 'OneOrMany' }
    } as ErConnectorShapeModel
  },
  // Zero or one
  {
    id: 'er_zero_or_one',
    sourcePoint: { x: 100, y: 260 },
    targetPoint: { x: 300, y: 260 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'ZeroOrOne' },
      targetMultiplicity: { type: 'ZeroOrOne' }
    } as ErConnectorShapeModel
  },
  // Zero or many
  {
    id: 'er_zero_or_many',
    sourcePoint: { x: 100, y: 300 },
    targetPoint: { x: 300, y: 300 },
    shape: {
      type: 'Er',
      sourceMultiplicity: { type: 'ZeroOrMany' },
      targetMultiplicity: { type: 'ZeroOrMany' }
    } as ErConnectorShapeModel
  }
];

// Initialize diagram control
function App() {
  return (
    <DiagramComponent id="container"
      width={'100%'}
      height={'600px'}
      connectors={connectors}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

See also